<template>
  <div class="container">
    <!-- 查询配置 -->
    <div style="padding: 0px 20px">
      <div ref="lxHeader">
        <LxHeader icon="md-apps" text="特殊时段设置" style="margin-bottom: 10px; border: 0px; margin-top: 15px">
          <div slot="content"></div>
          <slot>
            <div>
              <Input style="width: 200px; margin-right: 10px" v-model="searchFields.name" placeholder="关键字搜索" />
              <Button type="primary" @click="load" style="margin-left: 10px">查询</Button>
              <Button type="primary" @click="edit()" style="margin-left: 10px">新增</Button>
            </div>
          </slot>
        </LxHeader>
      </div>
      <div class="table-tree">
        <el-table :data="tableData" :height="tableHeight" style="width: 100%">
          <el-table-column type="index" width="50" align="center" label="序号"> </el-table-column>
          <el-table-column :prop="column.field" :align="column.align" v-for="(column,index) in columns"
            :label="column.title" :width="column.width">
            <template slot-scope="scope">
              <div v-if="column.type=='opt'">
                <Button ghost size="small" @click="edit(scope.row)" type="primary"
                  style="margin-left: 10px;">编辑</Button>
                <Button ghost size="small" type="error" @click="del(scope.row)" style="margin-left: 10px;">删除</Button>
              </div>
              <div v-else-if="column.type=='type'" v-for="item in parameters.visitType">
                <div v-if="item.id==scope.row[column.field]">
                  {{item.value}}
                </div>
              </div>
              <div v-else>{{scope.row[column.field]}}</div>
            </template>
          </el-table-column>
        </el-table>
        <div class="pagination">
          <el-pagination @current-change="handleCurrentChange" :current-page="paginations.page"
            :page-size="paginations.page_size" background layout="prev, pager, next" :total="paginations.total">
          </el-pagination>
        </div>
      </div>
    </div>

    <el-dialog title="详情编辑" :visible.sync="dialogFormVisible" fullscreen width="90%">
      <el-form :model="form" :rules="rules" ref="form" label-position="right" :label-width="formLabelWidth">
        <el-form-item label="名称" prop="name">
          <el-input v-model="form.name" placeholder="请填写名称" autocomplete="off"></el-input>
        </el-form-item>
        <el-form-item label="类型" prop="type">
          <el-select @change="showYy" v-model="form.type" placeholder="请选择类型" style="width:100%">
            <el-option v-for="item in parameters.visitType" :key="item.value" :label="item.value" :value="item.id">
            </el-option>
          </el-select>
        </el-form-item>
        <el-row>
          <el-col :span="10">
            <el-form-item label="开始时间" prop="start_date">
              <template slot-scope="scope">
                <el-date-picker
                  style="width:100%"
                  v-model="form.start_date"
                  type="date"
                  value-format="yyyy-MM-dd"
                  placeholder="选择开始时间">
                </el-date-picker>
              </template>
            </el-form-item>
          </el-col>
          <el-col :span="10" :offset="4">
            <el-form-item label="结束时间" prop="end_date">
              <template slot-scope="scope">
                <el-date-picker
                  style="width:100%"
                  v-model="form.end_date"
                  type="date"
                  value-format="yyyy-MM-dd"
                  placeholder="选择结束时间">
                </el-date-picker>
              </template>
            </el-form-item>
          </el-col>
        </el-row>
        <div v-if="isRules" style="padding: 20px 0px;" class="form-sub-title">
          <span>预约时间
          </span>
        </div>
        <div v-if="isRules" class="table-tree tableswidth">
          <div style="display: flex;justify-content: flex-end;margin-right: 20px;margin-bottom: 10px;">
            <Button type="primary" @click="addRow()" size="small" style="margin-left: 10px;" ghost>新增</Button>
          </div>
          <el-table :data="form.rules_list" height="400" class="v-table" style="width: 100%;margin-bottom: 20px;">
            <el-table-column type="index" align="center">
            </el-table-column>
            <el-table-column prop="start_time" label="开始时间">
              <template slot-scope="scope">
                <el-time-select
                  style="width:100%"
                  v-model="scope.row.start_time"
                  :picker-options="{
                    start: '00:00',
                    step: '00:15',
                    end: '24:00'
                  }"
                  placeholder="选择开始时间">
                </el-time-select>
              </template>
            </el-table-column>
            <el-table-column prop="end_time" label="结束时间">
              <template slot-scope="scope">
                <el-time-select
                  style="width:100%"
                  v-model="scope.row.end_time"
                  :picker-options="{
                    start: '00:00',
                    step: '00:15',
                    end: '24:00',
                    minTime: scope.row.start_time
                  }"
                  placeholder="选择结束时间">
                </el-time-select>
              </template>
            </el-table-column>
            <el-table-column prop="total" label="可预约人数">
              <template slot-scope="scope">
                <el-input v-model="scope.row.total" placeholder="请填写可预约人数" autocomplete="off"></el-input>
              </template>
            </el-table-column>
            <el-table-column label="操作" width="120px" align="center">
              <template slot-scope="scope">
                <Button type="error" @click="delRow(scope.$index)" size="small" style="margin-left: 10px;"
                  ghost>删除</Button>
              </template>
            </el-table-column>
          </el-table>
        </div>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="resetForm('form')">取 消</el-button>
        <el-button type="primary" @click="submitForm('form')">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
  import LxHeader from "@/components/LxHeader/index.vue";
  import {
    listvisitspecial,
    store,
    save,
    del,
    get
  } from "../../api/resource/visitspecial.js";
  import {
    getparameteritem
  } from "../../api/system/dictionary.js"
  export default {
    components: {
      LxHeader
    },
    data() {
      return {
        dialogFormVisible: false,
        formLabelWidth: "120px",
        tableHeight: 0,
        isRules:false,
        //查询条件字段
        searchFields: {
          name: ""
        },
        tableData: [],
        paginations: {
          page: 1,
          page_size: 15,
          total: 0
        },
        parameters: {
          visitType:[{
            id:1,
            value:"闭馆"
          },{
            id:2,
            value:"修改预约时间"
          }]
        },

        form: {
          name: "",
          type:1,
          start_date:"",
          end_date:"",
          rules_list:[{
            start_time:"",
            end_time:"",
            total:""
          }]
        },

        columns: [
          {
            field: "name",
            title: "名称",
            type: "string",
          },
          {
            field: "type",
            title: "类型",
            type: "type",
            width:300,
            align:"center"
          },
          {
            field: "操作",
            title: "操作",
            width: 220,
            type: "opt",
          }
        ],
        rules: {
          name: [{
            required: true,
            message: '请输入名称',
            trigger: 'blur'
          }]

        },

      }
    },
    created() {
      this.initLoad();
      this.load();
    },
    mounted() {},
    methods: {
      initLoad() {
        var that = this;
        var clientHeight = document.documentElement.clientHeight
        var lxHeader_height = 96.5; //查询 头部
        var paginationHeight = 37; //分页的高度
        var topHeight = 50; //页面 头部
        let tableHeight = clientHeight - lxHeader_height - topHeight - paginationHeight - 20;
        that.tableHeight = tableHeight;
      },
      load() {
        var that = this;
        listvisitspecial({
          page: this.paginations.page,
          page_size: this.paginations.page_size,
          name:this.searchFields.name
        }).then(res => {
          this.tableData = res.data;
          this.paginations.total = res.total
        }).catch(error => {

        })
      },
      info(obj) {
        var that = this;
        get(obj.id).then(res => {
          let result = Object.assign(that.form, res);
          that.form = result;
          if(result.type==2){
            this.isRules = true;
          }
          that.form.rules_list = result.rules;
        }).catch(error => {
          //reject(error)
        })

      },
      edit(obj) {
        this.form = this.$options.data().form;
        this.clientHeight = document.documentElement.clientHeight - 84 - 110;
        if (obj) {
          var that = this;
          that.info(obj);
        } else {}
        this.dialogFormVisible = true;
      },
      submitForm(formName) {
        var that = this;
        this.$refs[formName].validate((valid) => {
          if (valid) {
            if(!this.isRules){
              that.form.rules_list = [{
                start_time:"",
                end_time:"",
                total:""
              }]
            }
            if (that.form.id) {
              save(that.form).then(response => {
                console.log(response)
                this.$Message.success('操作成功');
                that.dialogFormVisible = false;
                that.load();
              }).catch(error => {})
            } else {
              store(that.form).then(response => {
                console.log(response)
                this.$Message.success('操作成功');
                that.dialogFormVisible = false;
                that.load();
              }).catch(error => {})
            }

          } else {
            this.$Message.error('数据校验失败');
            return false;
          }
        });
      },
      resetForm(formName) {
        var that = this;
        this.isRules = false;
        this.$refs[formName].resetFields();
        that.dialogFormVisible = false;
      },
      del(obj) {
        var that = this;
        if (obj) {
          this.$Modal.confirm({
            title: '确认要删除数据？',
            onOk: () => {
              del(obj.id).then(response => {
                this.$Message.success('操作成功');
                that.load();
              }).catch(error => {
                console.log(error)
                reject(error)
              })
            },
            onCancel: () => {
              //this.$Message.info('Clicked cancel');
            }
          });
        }
      },
      showYy(val){
        console.log(val)
        this.isRules = !this.isRules
      },
      addRow() {
        var len = this.form.rules_list.length;
        this.form.rules_list.push({
          start_time: "",
          end_time:"",
          total:""
        });
      },
      delRow(index) {
        this.form.rules_list.splice(index, 1);
      },
      handleCurrentChange(page) {
        this.paginations.page = page;
        this.load();
      }
    }
  };
</script>
